<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <!-- Jquery && Bootstrap CDN -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- DataTable CDN -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>
    <!-- Font Awesome CDN -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css"
        integrity="sha512-z3gLpd7yknf1YoNbCzqRKc4qyor8gaKU1qmn+CShxbuBusANI9QpRohGBreCFkKxLhei6S9CQXFEbbKuqLg0DA=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />
    <style>
        .input-user {
            background-color: blue;
        }

        .thead-background {
            background-color: cornflowerblue;
        }
    </style>
</head>

<body>
    <div class="container-fluid">
        <h1 style="text-align: center;">F200-LỊCH SỬ QUAY DICE</h1>
        <div class="container-fluid jumbotron">
            <h4>Thông tin người chơi:</h4>
            <div class="row">
                <div class="col-sm-2 col-md-2 col-lg-2 col-xl-2"><label for="username">Username</label></div>
                <div class="col-sm-2 col-md-2 col-lg-2 col-xl-2"><input disabled class="form-control input-user"
                        type="text" id="username" /></div>
                <div class="col-sm-2 col-md-2 col-lg-2 col-xl-2"><label for="firstname">Firstname</label></div>
                <div class="col-sm-2 col-md-2 col-lg-2 col-xl-2"><input disabled class="form-control input-user"
                        type="text" id="firstname" /></div>
                <div class="col-sm-2 col-md-2 col-lg-2 col-xl-2"><label for="lastname">Lastname</label></div>
                <div class="col-sm-2 col-md-2 col-lg-2 col-xl-2"><input disabled class="form-control input-user"
                        type="text" id="lastname" /></div>
            </div>

        </div>
        <table class="table table-bordered table-hover table-tripped">
            <thead class="thead-dark thead-background">
                <tr>
                    <th>Lần chơi</th>
                    <th>Kết quả</th>
                </tr>
            </thead>
            <tbody id="table-body"></tbody>
        </table>
    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading()
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        var vUser = {
            username: "",
            firstname: "",
            lastname: ""
        }
        // b1 thu thập dữ liệu
        getDataToForm(vUser)
        // B2 Kiểm tra dữ liệu [Không cần]
        // B3 Gọi Api
        processApiToDisplay(vUser)
        // B4 Xử lý hiển thị
        displayData(vUser)

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm thu thập dữ liệu để load vào các ô input
    function getDataToForm(paramObject) {
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        paramObject.username = vUrl.searchParams.get("username")
        paramObject.firstname = vUrl.searchParams.get("firstname")
        paramObject.lastname = vUrl.searchParams.get("lastname")
    }
    // hàm hiển thị thông tin user
    function displayData(paramObject) {
        $("#username").val(paramObject.username)
        $("#firstname").val(paramObject.firstname)
        $("#lastname").val(paramObject.lastname)
    }
    // Hàm gọi Api để load ra table
    function processApiToDisplay(paramObject) {
        $.ajax({
            url: gBASE_URL + "/dice-history?username=" + paramObject.username,
            type: "GET",
            success: function (responseObject) {
                console.log(responseObject)
                displayDiceHistory(responseObject)
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        })
    }
    // hàm load dữ liệu dice ra bảng
    function displayDiceHistory(paramResponse) {
        var vTbody = $("#table-body")
        vTbody.html("")
        for (var bI = 0; bI < paramResponse.dices.length; bI++) {
            vTbody.append(`<tr>
                <td>${bI + 1}</td>
                <td>${paramResponse.dices[bI]}</td>
                </tr>`)
        }
    }
</script>

</html>